# Introduction

DexCharts is a library which provides powerful visualization capabilities within the browser.

Pardon the dust right now.  I am in the middle of a documentation and refactoring effort.

## Live Examples

There are many examples bundled with DexCharts.  Here are a few.


| Chart Type             | Short Description | Long Description |
|:--------------------------- |:----------------- |:-- |
| [Bar Chart](#bar-chart)     | [Basic Example](http://dexvis.com/dexcharts/dist/current/examples/BarChart1.html) | This example demonstrates the basic use of a bar chart. |
| [Bar Chart](#bar-chart)     | [High Resolution](http://dexvis.com/dexcharts/dist/current/examples/BarChart2.html) |  This chart looks like a line chart, however, in reality it is a fine grained bar chart. |
| [Bar Chart](#bar-chart)     | [Styling](http://dexvis.com/dexcharts/dist/current/examples/BarChart3.html) | This demonstrates some of the styling options associated with a bar chart. |
| [Chord Chart](#chord-chart) | [Basic Example](http://dexvis.com/dexcharts/dist/current/examples/Chord1.html)| This is a basic example of a chord chart. |
| [Chord Chart](#chord-chart) | [Styling](http://dexvis.com/dexcharts/dist/current/examples/Chord2.html) | This is a more complicated example demonstrating parallel coordinates chart dynamically creating a Chord Chart. |
| [Dendrogram](#dendrogram)   | [Dendrogram 1](http://dexvis.com/dexcharts/dist/current/examples/Dendrogram1.html) ||
| [Dendrogram](#dendrogram)   | [Dendrogram 2](http://dexvis.com/dexcharts/dist/current/examples/Dendrogram2.html) ||
| [Dendrogram](#dendrogram)   | [Dendrogram 3](http://dexvis.com/dexcharts/dist/current/examples/Dendrogram3.html) ||
| Heat Map               | [HeatMap 1](http://dexvis.com/dexcharts/dist/current/examples/HeatMap1.html) ||
| Horizontal Legend      | [Horizontal Legend 1](http://dexvis.com/dexcharts/dist/current/examples/HorizontalLegend1.html) ||
| Legends                | [Legend 1](http://dexvis.com/dexcharts/dist/current/examples/Legends1.html) ||
| Line Chart             | [Line Chart 1](http://dexvis.com/dexcharts/dist/current/examples/LineChart1.html) ||
| Line Chart             | [Line Chart 2](http://dexvis.com/dexcharts/dist/current/examples/LineChart2.html) ||
| Line Chart             | [Line Chart 3](http://dexvis.com/dexcharts/dist/current/examples/LineChart3.html) ||
| Line Chart             | [Line Chart 4](http://dexvis.com/dexcharts/dist/current/examples/LineChart4.html) ||
| Parallel Coordinates   | [Parallel Coordinates 1](http://dexvis.com/dexcharts/dist/current/examples/ParallelCoordinates1.html)||
| Parallel Coordinates   | [Parallel Coordinates 2](http://dexvis.com/dexcharts/dist/current/examples/ParallelCoordinates2.html)||
| Parallel Coordinates   | [Parallel Coordinates 3](http://dexvis.com/dexcharts/dist/current/examples/ParallelCoordinates3.html)||
| Parallel Coordinates   | [Parallel Coordinates 4](http://dexvis.com/dexcharts/dist/current/examples/ParallelCoordinates4.html)||
| Pie Chart              | [Pie Chart 1](http://dexvis.com/dexcharts/dist/current/examples/PieChart1.html) ||
| Pie Chart              | [Pie Chart 2](http://dexvis.com/dexcharts/dist/current/examples/PieChart2.html) ||
| Pie Chart              | [Pie Chart 3](http://dexvis.com/dexcharts/dist/current/examples/PieChart3.html)||
| Sankey                 | [Sankey 1](http://dexvis.com/dexcharts/dist/current/examples/Sankey1.html)||
| Sankey                 | [Sankey 2](http://dexvis.com/dexcharts/dist/current/examples/Sankey2.html)||
| Sankey                 | [Sankey 3](http://dexvis.com/dexcharts/dist/current/examples/Sankey3.html)||
| Sankey                 | [Sankey 4](http://dexvis.com/dexcharts/dist/current/examples/Sankey4.html)||
| Sankey                 | [Sankey 5](http://dexvis.com/dexcharts/dist/current/examples/Sankey5.html)||
| Sankey                 | [Sankey 6](http://dexvis.com/dexcharts/dist/current/examples/Sankey6.html)||
| Sankey                 | [Sankey 7](http://dexvis.com/dexcharts/dist/current/examples/Sankey7.html)||
| Sankey                 | [Sankey 8](http://dexvis.com/dexcharts/dist/current/examples/Sankey8.html)||
| Sankey                 | [Sankey 9](http://dexvis.com/dexcharts/dist/current/examples/Sankey9.html)||
| Scatter Plot           | [Scatter Plot 1](http://dexvis.com/dexcharts/dist/current/examples/ScatterPlot1.html)||
| Scatter Plot           | [Scatter Plot 2](http://dexvis.com/dexcharts/dist/current/examples/ScatterPlot2.html)||
| 3D Scatter Plot        | [3D Scatter Plot 1](http://dexvis.com/dexcharts/dist/current/examples/ScatterPlot3D1.html)||
| 3D Scatter Plot        | [3D Scatter Plot 2](http://dexvis.com/dexcharts/dist/current/examples/ScatterPlot3D2.html)||
| 3D Scatter Plot        | [3D Scatter Plot 3](http://dexvis.com/dexcharts/dist/current/examples/ScatterPlot3D3.html)||
| Scatter Plot Matrix    | [Scatter Plot Matrix](http://dexvis.com/dexcharts/dist/current/examples/ScatterPlotMatrix1.html)||
| Map                    | [State Map 1](http://dexvis.com/dexcharts/dist/current/examples/StateMap1.html)||
| Map                    | [State Map 2](http://dexvis.com/dexcharts/dist/current/examples/StateMap2.html)||
| UI Controls            | [UI Controls 1](http://dexvis.com/dexcharts/dist/current/examples/UI1.html)||
| UI Controls            | [UI Controls 2](http://dexvis.com/dexcharts/dist/current/examples/UI2.html)||
| UI Controls            | [UI Controls 3](http://dexvis.com/dexcharts/dist/current/examples/UI3.html)||
| UI Controls            | [UI Controls 4](http://dexvis.com/dexcharts/dist/current/examples/UI4.html)||
| Map                    | [US County Map 1](http://dexvis.com/dexcharts/dist/current/examples/USCountyMap1.html)||
| Vertical Legend        | [Vertical Legend 1](http://dexvis.com/dexcharts/dist/current/examples/VerticalLegend1.html)||
| Map                    | [World Country Map 1](http://dexvis.com/dexcharts/dist/current/examples/WorldCountryMap1.html)||

## Usage

_**Step 1: Include D3**_

Make sure your HTML5 asset includes D3 like so:

```javascript
<script src="http://d3js.org/d3.v3.js"></script>
```

_**Step 2: Include DexCharts core**_

Now include the core DexCharts Javascript like so:

```javascript
<script src="../dex.js"></script>
```

_**Step 3: Include the specific components you will need:**_

Some components such as maps are quite large, so I decided that components should be required as needed instead of in one massive kitchen sink Javascript library.  Here, I am including a Bar Chart and a Horizontal Legend.

```javascript
<script src="../js/dex/component/d3/BarChart.js"></script>
<script src="../js/dex/component/d3/HorizontalLegend.js"></script>
```

_**Step 4: Include D3**_

Create one or more SVG containers for your charts::

Via html:

Or you can do it via html like this:

```html
<svg id="MyChart" width="1000" height="1000"></svg>
```

Or you can create the SVG in JavaScript code:

```javascript
var svg = d3.select("body").append("svg")
  .attr("id", "MyChart")
  .attr("width", 1000)
  .attr("height", 800)
  .append("g")
  .attr("transform", "translate(40,20)");
```

_**Step 5: Instantiate a chart**_

Next, we must configure and instantiate a chart.

```javascript
var mychart = new BarChart(
  {
    'parent' : '#MyChart',
    'csv'    :
    {
      'header' : [ "SALESMAN", "AGE", "SALES"],
      'data'   : [["BOB", 23, 1000], ["SUE", 32, 2000], ["PAT", 44, 3000]]
    }
  }
);
```

_**Step 6:**_

Render the chart.

```javascript
mychart.render();
```

### What else?

_**We can reconfigure and update our chart in one line.**_

This will change the simple bar chart to a grouped bar chart which will have columns for both AGE and SALES.

```javascript
mychart.attr("yi", [1, 2]).update();
```

_**We can create new charts from old charts.**_

Here we create a new chart called myotherchart from mychart.  It will inherit all parameters from the original.  Of course, this makes no sense, so we change the x/y offsets to display at a different location on the screen.

In two lines we are creating another permutation of a chart and rendering it!

```javascript
var myotherchart = new BarChart(mychart);
myotherchart.attr("yoffset", 400).render();
```

_**We can combine charts and tell them to listen to other another.**_

Here, we're telling our parallel coordinates chart (pcChart), to listen to our USStateMap named "map" when it generates a "selectState" event.  Data is passed through an object called chartEvent.

In this particular example, we're removing the old parallel lines chart, adding the selected state data to the data list, then updating the chart.  A live example of this visualization [US State Map wired to Parallel Coordinates](http://dexvis.com/vis/blog/2013/mar/reusable6/html/ParallelCoordinates3.html):

```javascript
map.addListener("selectState", pcChart, function(chartEvent)
  {
    if (stateMap[chartEvent.state] != null)
  	{
  	  d3.selectAll("#ParChart").remove();
  	  selectedStates[chartEvent.state] = true;

  	  var pcData = []
  	  
  	  for (var state in selectedStates)
  	  {
  	  	pcData.push(stateMap[state]);
  	  }
	  pcChart
	    .attr("normalize", pcData.length <= 1)
	    .attr("csv.data", pcData)
	    .attr("height", 200)
	    .update();
  	}
  });
```

# Configuration

Most configuration options can be configured with literals or dynamic functions.  Most of the visuals include reusable configurable types such as:

* Basic Shapes such as lines, circles and rectangles.
* Strokes
* Labels, fonts, etc...

## General

### Fonts

| Option  | Default    | Description |
| ------- |:-----------| -----:|
| family  | sans-serif | Sets the basic font family.  Ex: 'Arial'. |
| size    | 18         | Sets the size, in pixels, of the font. |
| style   | normal     | Sets the style of the font. Ex: normal, italic, oblique |
| variant | normal     | Sets the font variant.  Ex: normal, small-caps |
| weight  | normal     | Sets the weight of the font.  Ex: normal, bold, 100, 200, 300, 400, 500, 600, 700, 800, 900 |


### Strokes

| Option    | Default | Description |
| --------- |:--------| -----:|
| color     | black   | Sets the color of the stroke. Named colors and colors of the form #fff and #ffffff are accepted. |
| dasharray | empty   | Sets the pattern of the line to be drawn.  Ex: '1 1' would be a dashed line. |
| opacity   | 1       | Sets the opacity.  Values range from 0 to 1 with 0 representing a stroke which is fully tranparent and 1 representing a stroke which is fully opaque. |
| width     | 1       | Sets the width (in pixels) of the stroke. |

### Fills

| Option      | Default | Description |
| ----------- |:--------| -----:|
| fill        |         | Sets the color of the entity to be filled. |
| fillOpacity |         | Sets the opacity of the filling. |

### Links

| Option      | Default | Description |
| ----------- |:--------| -----:|
| stroke      | [Stroke](#strokes)  | See Strokes. |
| fill        |         | Sets the color of the entity to be filled. |
| fillOpacity |         | Sets the opacity of the filling. 

### Labels

| Option     | Default | Description |
| ---------- |:------------| -----:|
| x                        | 0     | Sets the x location of this label. |
| y                        | 0     | Sets the y location of this label. |
| transform                | 0     | Applies a SVG transformation to this label. |
| dy                       | .71em | Sets the number of minor ticks to display. |
| font                     | [Font](#fonts)  | Sets the font for this label.  See: Fonts. |
| text                     | ''    | Sets the text value of this label. |
| anchor                   | 5     | Sets the anchor of this label.  Ex: start, middle, end |
| color                    | 5     | Sets the color of the label. |
| textLength               | ',d'  | Sets the length of the text.  The text will be adjusted to fit this length. |
| lengthAdjust             |       | Configures the tick label.  See Label configuration options. |
| writingMode              |       | Specifies whether the text is left to right, right to left, top to bottom, etc... Ex: lr-tb, rl-tb, tb-rl, lr, rl, tb, inherit |
| glyphOrientationVertical |       | The glyph orientation affects the amount that the current text position advances as each glyph is rendered.  |
  

### Ticks

| Option     | Default | Description |
| ---------- |:------| -----:|
| count      | 5     | Sets the number of major ticks to display. |
| subdivide  | 3     | Sets the number of minor ticks to display. |
| size.major | 5     | Sets the size (in pixels) of the major ticks. |
| size.minor | 3     | Sets the size (in pixels) of the minor ticks. |
| size.end   | 5     | Sets the size (in pixels) of the ticks at either end of the axis. |
| padding    | 5     | Sets the padding. |
| format     | ',d'  | Sets the format of the tick labels. |
| label      | [Label](#labels) | Configures the tick label.  See Label configuration options. |

### Axis

| Option | Default | Description |
| ------ |:--------| -----------:|
| tick   | [Tick](#ticks)    | See Ticks. |
| orient | 3       | Sets the orientation of the axis. Ex: top, bottom, left, right. |
| scale  | 5       | Set the scale of the axis.  Ex: d3.scale.linear(), d3.scale.ordinal() |
| label  | [Label](#labels)   | See Labels. |

### CSV

| Option     | Default | Description |
| ---------- |:--------| -----------:|
| header     | []   | An array containing the names of each column.  Ex: [ 'C1', 'C2' ] |
| data       | [[]] | An array of arrays.  Each row of the array represents a row of data.  Ex: [[1, 2],[3,4]] |

### Shapes

#### Points

| Option | Default | Description |
| ------ |:--------| -----------:|
| x      | 0       | The x coordinate of the point. |
| y      | 0       | The y coordinate of the point. |

#### Rectangles

| Option  | Default | Description |
| ------- |:--------| -----------:|
| width   | 0       | The width of the rectangle in pixels. |
| height  | 0       | The height of the rectangle in pixels. |
| x       | 0       | The x coordinate of the upper left vertex of the rectangle. |
| y       | 0       | The y coordinate of the upper left vertex of the rectangle. |
| rx      | 0       | The x radius of the edges of the rectangle.  Non-zero values will cause the rectangle to be rounded at the corners.  |
| ry      | 0       | The y radius of the edges of the rectangle.  Non-zero values will cause the rectangle to be rounded at the corners.  |
| opacity | 1       | The opacity of the rectangle where 0 is transparent, 1 is opaque. |
| color   |         | The color of the rectangle. |
| stroke  | [Stroke](#strokes)  | See Strokes. |


#### Circles

| Option        | Default | Description |
| ------------- |:--------| -----------:|
| center        | [Point](#points)   | The center of the circle.  See Points. |
| radius        | 0       | The radius of the circle in pixels. |
| style.stroke  | [Stroke](#strokes)  | See Strokes. |
| style.color   |         | The color of the circle. |
| style.opacity | 1       | The opacity of the circle.  |

## Visual Components

### Bar Chart

A bar chart or bar graph is a chart with rectangular bars with lengths proportional to the values that they represent. The bars can be plotted vertically or horizontally. A vertical bar chart is sometimes called a column bar chart.  Ironically, this, the simplest of charts, has given me the most trouble.  I need to invest quite a bit more time into this component, however, it is currently usable at least.

| Option         | Default   | Description |
| -------------- |:----------| ----------:|
| parent         |           | The path to this component's parent element.  Ex: #BarChartParent |
| id             | BarChart  | The id of this component's container element. |
| class          | BarChart  | The class of this component's container element. |
| csv            |           | The data for this diagram.  See CSV. |
| width          | 600       | The width of this chart. |
| height         | 400       | The height of this chart. |
| xi             | 0         | The index of the column which will be used for the x axis. |
| yi             | [1]       | An array of indices for the columns which will be used for the y axis values. |
| xoffset        | 50        | Move the chart left (negative values) or to the right (positive values). |
| yoffset        | 10        | Move the chart up (negative values) or down (positive values) |
| color          |           | Determines the color for each group of bars. |
| xmin           | 0         | The minimum x value. Ex: if 0, will cause the x axis to begin at 0. |
| ymin           | 0         | The minimum y value. Ex: if 0, will cause the bars to start at minimum value 0. |
| bars.mouseover | [Rectangle](#rectangles) | This controls the appearance of the bars when the mouse is over them. |
| bars.mouseout  | [Rectangle](#rectangles) | This controls the appearance of the bars when the mouse is not over them. |


### Chord Chart

| Option          | Default  | Description |
| --------------- |:---------| -----------:|
| parent          |          | The path to this component's parent element.  Ex: #ChordChartParent |
| id              | Chord    | The id of this component's container element. |
| class           | Chord    | The class of this component's container element. |
| csv             |          | The data for this diagram.  See CSV. |
| width           | 600      | The width of this chart. |
| height          | 400      | The height of this chart. |
| transform       | 50       | Apply a SVG transform to the chart. |
| padding         | 0.05     | Controls the padding between chords. |
| color           |          | Controls the color scheme of the chords and links. |
| nodes.mouseover | [Link](#links)     | Controls the appearance of nodes when the mouse is over them. See Links. |
| links.mouseout  | [Link](#links)     | Controls the appearance of nodes when the mouse is not over them. See Links. |
| links.mouseover | [Link](#links)     | Controls the appearance of links when the mouse is over them. See Links. |
| nodes.mouseout  | [Link](#links)     | Controls the appearance of links when the mouse is not over them. See Links. |
| opacity         | 100      | Controls the opacity of the chord links. |
| chordOpacity    | 50       | Controls the opacity of the chords. |
| innerRadius     | 130      | This controls the inner radius of the chord diagram. |
| outerRadius     | 200      | This controls the outer radius of the chord diagram. |
| tick            | [Line](#lines)   | This controls the appearance of the tick.  See Lines. |
| tick.length     |          | An additional field specifying the length of the tick. |
| title           | [Label](#labels)    | This controls the appearance of the title.  See Labels. |
| label           | [Label](#labels)    | This controls the appearance of the chord labels. See Labels. |

### Clustered Force

| Option                     | Default        | Description |
| -------------------------- |:---------------| -----:|
| parent                     |                | The path to this component's parent element.  Ex: #ClusteredForceParent |
| id                         | ClusteredForce | The id of this component's container element. |
| class                      | ClusteredForce | The class of this component's container element. |
| csv                        |                | The data for this diagram.  See CSV. |

### Dendrogram

| Option                     | Default    | Description |
| -------------------------- |:-----------| -----:|
| parent                     |            | The path to this component's parent element.  Ex: #DendrogramParent |
| id                         | Dendrogram | The id of this component's container element. |
| class                      | Dendrogram | The class of this component's container element. |
| csv                        |            | The data for this diagram.  See CSV. |

### HeatMap

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #HeatMapParent |
| id                         | HeatMap  | The id of this component's container element. |
| class                      | HeatMap  | The class of this component's container element. |
| csv                        |          | The data for this diagram.  See CSV. |

### Horizontal Legends

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #HorizontalLegendParent |
| id                         | HorizontalLegend | The id of this component's container element. |
| class                      | HorizontalLegend | The class of this component's container element. |
| csv                        |         | The data for this diagram.  See CSV. |

### Line Charts

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #LineChartParent |
| id                         | LineChart | The id of this component's container element. |
| class                      | LineChart | The class of this component's container element. |
| csv                        |         | The data for this diagram.  See CSV. |

### Parallel Coordinates

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #ParCoordParent |
| id                         | ParCoord | The id of this component's container element. |
| class                      | ParCoord | The class of this component's container element. |
| csv                        |         | The data for this diagram.  See CSV. |

### Pie Chart

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #PieChartParent |
| id                         | PieChart | The id of this component's container element. |
| class                      | PieChart | The class of this component's container element. |
| csv                        |         | The data for this diagram.  See CSV. |

### Sankey Diagram

| Option                     | Default | Description |
| -------------------------- |:--------| -----:|
| parent                     |         | The path to this component's parent element.  Ex: #SankeyParent |
| id                         | Sankey  | The id of this component's container element. |
| class                      | Sankey  | The class of this component's container element. |
| csv                        |         | The data for this diagram.  See CSV. |
| relationships              |         | The relationship data for this diagram, whose format is described in greater detail later in this section. |
| height                     | 100%    | The height of the sankey diagram in either pixels or a percentage of available bounding box size. |
| width                      | 100%    | The width of the sankey diagram in either pixels or a percentage of available bounding box size. |
| transform                  |         | The SVG transformation(s) to apply. |
| layoutIterations           | 32      | The number of iterations to expend when attempting to optimize node and link layout. |
| columnTitle                | [Label](#labels)   | The label for each column. See Labels. |
| label                      | [Label](#labels)   | The label for each node.  See Labels. |
| link.stroke                | [Stroke](#strokes) | The stroke for each link.  See Strokes. |
| link.fill                  | none    | The fill for each link. |
| link.fillOpacity           |         | The fillOpacity for each link. |
| link.curvature             | 0.5     | Radians of curvature. |
| mouseover.link.stroke      | [Stroke](#strokes)  | The stroke of a link when the mouse is moved over it. |
| mouseover.link.fill        | none    | The fill of the link when the mouse is over it. |
| mouseover.link.fillOpacity | 0.8     | The fill opacity of the link when the mouse is over it. |
| mouseover.node.stroke      | [Stroke](#strokes)  | Tne stroke of all of the incoming and outgoing links from this node when the mouse is moved over it.  See Strokes.|
| mouseover.node.fill        | none    | The fill of all the incoming and outgoing links from this node when the mouse is moved over it. |
| mouseover.node.fillOpacity | .8      | The fill opacity of all the incoming and outgoing links from this node when the mouse is moved over it. |
| node.padding | 4 | The padding around each node segregating labels and other nodes. |
| node.rectangle | RECTANGLE | This controls the appearance of each node.  See Rectangles. |
| manualColumnLayout | false   | If false, Sankey will attempt to lay the nodes out in an optimized fashion.  However, if true, then the system will assume that each column of data represesents a column of nodes and will align columnar nodes on top of one another.  The first column will be leftmost in the layout.  Manual layout is much faster automated layout. |

### Scatter Plot

Is it one word or two?  This is a mystery which has haunted engineers throughout time.  Either way, scatterplots are a very useful way to quickly understand a numeric or even ordinal distributions.

| Option                     | Default     | Description |
| -------------------------- |:------------| -----:|
| parent                     |             | The path to this component's parent element.  Ex: #ScatterPlotParent |
| id                         | ScatterPlot | The id of this component's container element. |
| class                      | ScatterPlot | The class of this component's container element. |
| csv                        |             | The data for this diagram.  See CSV. |

### UI Controls

This section contains controls which can be dropped into a Dex Chart.

#### Configuration Box

| Option                     | Default   | Description |
| -------------------------- |:----------| -----:|
| parent                     |           | The path to this component's parent element.  Ex: #ConfigBoxParent |
| id                         | ConfigBox | The id of this component's container element. |
| class                      | ConfigBox | The class of this component's container element. |
| csv                        |           | The data for this diagram.  See CSV. |

#### Selectable

| Option                     | Default    | Description |
| -------------------------- |:-----------| -----:|
| parent                     |            | The path to this component's parent element.  Ex: #SelectableParent |
| id                         | Selectable | The id of this component's container element. |
| class                      | Selectable | The class of this component's container element. |
| csv                        |            | The data for this diagram.  See CSV. |

#### Slider

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #SliderParent |
| id                         | Slider   | The id of this component's container element. |
| class                      | Slider   | The class of this component's container element. |
| csv                        |          | The data for this diagram.  See CSV. |

#### Tabs

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #TabsParent |
| id                         | Tabs     | The id of this component's container element. |
| class                      | Tabs     | The class of this component's container element. |
| csv                        |          | The data for this diagram.  See CSV. |

### ThreeJS

These are WebGL components based primarily up on the excellent work of mrdoob.  They will not currently render on IOS devices.

#### ScatterPlot3D

| Option                     | Default       | Description |
| -------------------------- |:--------------| -----:|
| parent                     |               | The path to this component's parent element.  Ex: #ScatterPlot3DParent |
| id                         | ScatterPlot3D | The id of this component's container element. |
| class                      | ScatterPlot3D | The class of this component's container element. |
| csv                        |               | The data for this diagram.  See CSV. |

### Maps

#### US County Map

| Option                     | Default     | Description |
| -------------------------- |:------------| -----:|
| parent                     |             | The path to this component's parent element.  Ex: #USCountyMapParent |
| id                         | USCountyMap | The id of this component's container element. |
| class                      | USCountyMap | The class of this component's container element. |
| csv                        |             | The data for this diagram.  See CSV. |

#### US State Map

| Option                     | Default    | Description |
| -------------------------- |:-----------| -----:|
| parent                     |            | The path to this component's parent element.  Ex: #USStateMapParent |
| id                         | USStateMap | The id of this component's container element. |
| class                      | USStateMap | The class of this component's container element. |
| csv                        |            | The data for this diagram.  See CSV. |

#### World Country Map

| Option                     | Default  | Description |
| -------------------------- |:---------| -----:|
| parent                     |          | The path to this component's parent element.  Ex: #WorldMapParent |
| id                         | WorldMap | The id of this component's container element. |
| class                      | WorldMap | The class of this component's container element. |
| csv                        |          | The data for this diagram.  See CSV. |

### Vertical Legend

| Option                     | Default        | Description |
| -------------------------- |:---------------| -----:|
| parent                     |                | The path to this component's parent element.  Ex: #VerticalLegendParent |
| id                         | VerticalLegend | The id of this component's container element. |
| class                      | VerticalLegend | The class of this component's container element. |
| csv                        |                | The data for this diagram.  See CSV. |
